# RPMDIntegrator Class Reference

This is an Integrator which simulates a System using ring polymer molecular dynamics (RPMD). More...

Inheritance diagram for RPMDIntegrator:

List of all members.

## Public Member Functions

def | getNumCopies
| getNumCopies(self) -> int
def | getTemperature
| getTemperature(self) -> double
def | setTemperature
| setTemperature(self, double temp)
def | getFriction
| getFriction(self) -> double
def | setFriction
| setFriction(self, double coeff)
def | getApplyThermostat
| getApplyThermostat(self) -> bool
def | setApplyThermostat
| setApplyThermostat(self, bool apply)
def | getRandomNumberSeed
| getRandomNumberSeed(self) -> int
def | setRandomNumberSeed
| setRandomNumberSeed(self, int seed)
def | getContractions
| getContractions(self) -> mapii
def | setPositions
| setPositions(self, int copy, std.vector<(Vec3,std.allocator<(Vec3)>)> positions)
def | setVelocities
| setVelocities(self, int copy, std.vector<(Vec3,std.allocator<(Vec3)>)> velocities)
def | getTotalEnergy
| getTotalEnergy(self) -> double
def | step
| step(self, int steps)
def | getState
| getState(self, copy, getPositions = False, getVelocities = False, getForces = False, getEnergy = False, getParameters = False, enforcePeriodicBox = False, groups = -1) -> State
def | __init__
| __init__(self, int numCopies, double temperature, double frictionCoeff, double stepSize) -> RPMDIntegrator __init__(self, int numCopies, double temperature, double frictionCoeff, double stepSize, mapii contractions) -> RPMDIntegrator __init__(self, RPMDIntegrator other) -> RPMDIntegrator
def | __del__
| __del__(self)

## Public Attributes

| this

## Detailed Description

This is an Integrator which simulates a System using ring polymer molecular dynamics (RPMD).

It simulates many copies of the System, with successive copies connected by harmonic springs to form a ring. This allows certain quantum mechanical effects to be efficiently simulated.

By default this Integrator applies a PILE thermostat to the system to simulate constant temperature dynamics. You can disable the thermostat by calling setApplyThermostat(false).

Because this Integrator simulates many copies of the System at once, it must be used differently from other Integrators. Instead of setting positions and velocities by calling methods of the Context, you should use the corresponding methods of the Integrator to set them for specific copies of the System. Similarly, you should retrieve state information for particular copies by calling getState() on the Integrator. Do not query the Context for state information.

You can optionally specify a set of "ring polymer contractions", by which different force groups are evaluated on different numbers of copies, instead of computing every force on every copy. This can be much more efficient, since different forces may vary widely in how many times they must be evaluated to produce sufficient accuracy. For example, you might simulate a 32 copy ring polymer and evaluate bonded forces on every copy, but contract it down to only 6 copies for computing nonbonded interactions, and down to only a single copy (the centroid) for computing the reciprocal space part of PME.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Integrator.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self, int numCopies, double temperature, double frictionCoeff, double stepSize) -> RPMDIntegrator __init__(self, int numCopies, double temperature, double frictionCoeff, double stepSize, mapii contractions) -> RPMDIntegrator __init__(self, RPMDIntegrator other) -> RPMDIntegrator

Create a RPMDIntegrator.

Parameters:

  | numCopies | the number of copies of the system that should be simulated
  | temperature | the temperature of the heat bath (in Kelvin)
  | frictionCoeff | the friction coefficient which couples the system to the heat bath (in inverse picoseconds)
  | stepSize | the step size with which to integrator the system (in picoseconds)
  | contractions | the ring polymer contractions to use for evaluating different force groups. Each key in the map is the index of a force group, and the corresponding value is the number of copies to evaluate that force group on. If no entry is provided for a force group (the default), it is evaluated independently on every copy.

def getApplyThermostat | ( |  | self | ) |

getApplyThermostat(self) -> bool

Get whether a thermostat is applied to the system.

def getContractions | ( |  | self | ) |

getContractions(self) -> mapii

Get the ring polymer contractions to use for evaluating different force groups. Each key in the map is the index of a force group, and the corresponding value is the number of copies to evaluate that force group on. If no entry is provided for a force group, it is evaluated independently on every copy.

def getFriction | ( |  | self | ) |

getFriction(self) -> double

Get the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps).

def getNumCopies | ( |  | self | ) |

getNumCopies(self) -> int

Get the number of copies of the system being simulated.

def getRandomNumberSeed | ( |  | self | ) |

getRandomNumberSeed(self) -> int

Get the random number seed. See setRandomNumberSeed() for details.

def getState | ( |  | self,
|  |  | copy,
|  |  | getPositions = `False`,
|  |  | getVelocities = `False`,
|  |  | getForces = `False`,
|  |  | getEnergy = `False`,
|  |  | getParameters = `False`,
|  |  | enforcePeriodicBox = `False`,
|  |  | groups = `-1` |
| ) |  |  |

getState(self, copy, getPositions = False, getVelocities = False, getForces = False, getEnergy = False, getParameters = False, enforcePeriodicBox = False, groups = -1) -> State

Get a State object recording the current state information about one copy of the system.

Parameters:

  | copy | (int) the index of the copy for which to retrieve state information
  | getPositions | (bool=False) whether to store particle positions in the State
  | getVelocities | (bool=False) whether to store particle velocities in the State
  | getForces | (bool=False) whether to store the forces acting on particles in the State
  | getEnergy | (bool=False) whether to store potential and kinetic energy in the State
  | getParameter | (bool=False) whether to store context parameters in the State
  | enforcePeriodicBox | (bool=False) if false, the position of each particle will be whatever position is stored in the Context, regardless of periodic boundary conditions. If true, particle positions will be translated so the center of every molecule lies in the same periodic box.
  | groups | (int=-1) a set of bit flags for which force groups to include when computing forces and energies. Group i will be included if (groups&(1<<i)) != 0. The default value includes all groups.

def getTemperature | ( |  | self | ) |

getTemperature(self) -> double

Get the temperature of the heat bath (in Kelvin).

def getTotalEnergy | ( |  | self | ) |

getTotalEnergy(self) -> double

Get the total energy of the ring polymer. This includes the potential and kinetic energies of all copies, plus the potential energy of the harmonic springs that link copies together.

def setApplyThermostat | ( |  | self,
|  |  | args |
| ) |  |  |

setApplyThermostat(self, bool apply)

Set whether a thermostat is applied to the system.

def setFriction | ( |  | self,
|  |  | args |
| ) |  |  |

setFriction(self, double coeff)

Set the friction coefficient which determines how strongly the system is coupled to the heat bath (in inverse ps).

Parameters:

  | coeff | the friction coefficient, measured in 1/ps

def setPositions | ( |  | self,
|  |  | args |
| ) |  |  |

setPositions(self, int copy, std.vector<(Vec3,std.allocator<(Vec3)>)> positions)

Set the positions of all particles in one copy of the system.

Parameters:

  | copy | the index of the copy for which to set positions
  | positions | the positions of all particles in the system

def setRandomNumberSeed | ( |  | self,
|  |  | args |
| ) |  |  |

setRandomNumberSeed(self, int seed)

Set the random number seed. The precise meaning of this parameter is undefined, and is left up to each Platform to interpret in an appropriate way. It is guaranteed that if two simulations are run with different random number seeds, the sequence of random forces will be different. On the other hand, no guarantees are made about the behavior of simulations that use the same seed. In particular, Platforms are permitted to use non-deterministic algorithms which produce different results on successive runs, even if those runs were initialized identically.

def setTemperature | ( |  | self,
|  |  | args |
| ) |  |  |

setTemperature(self, double temp)

Set the temperature of the heat bath (in Kelvin).

Parameters:

  | temp | the temperature of the heat bath, measured in Kelvin

def setVelocities | ( |  | self,
|  |  | args |
| ) |  |  |

setVelocities(self, int copy, std.vector<(Vec3,std.allocator<(Vec3)>)> velocities)

Get the velocities of all particles in one copy of the system.

Parameters:

  | copy | the index of the copy for which to set velocities
  | velocities | the velocities of all particles in the system

def step | ( |  | self,
|  |  | args |
| ) |  |  |

step(self, int steps)

Advance a simulation through time by taking a series of time steps.

Parameters:

  | steps | the number of time steps to take

Reimplemented from Integrator.

## Member Data Documentation

this

Reimplemented from Integrator.

The documentation for this class was generated from the following file:

- openmm.py